%define anolis_release 2

Summary:    The GNU shar utilities for packaging and unpackaging shell archives
Name:       sharutils
Version:    4.15.2
Release:    %{anolis_release}%{dist}

# The main code:                GPLv3+
# intl/dngettext.c:             LGPLv2+
# lib (gnulib):                 GPLv3+
# lib/md5.c:                    GPLv3+ and Public Domain
# libopts/file.c:               LGPLv3+ or BSD
# libopts/genshell.h:           LGPLv2+
# libopts/m4/libopts.m4:        GPLv3+
# doc/sharutils.texi:           GFDL
# src/uuencode.c:               GPLv3+ and BSD
## Not in the binary package
# ar-lib:                       GPLv2+
# config.rpath:                 FSFULLR
# INSTALL:                      FSFAPP
# install-sh:                   MIT
License:    GPLv3+ and (GPLv3+ and BSD) and (LGPLv3+ or BSD) and LGPLv2+ and Public Domain and GFDL
URL:        http://www.gnu.org/software/%{name}/
Source:     http://ftp.gnu.org/gnu/%{name}/%{name}-%{version}.tar.xz

# Pass compilation with -Werror=format-security, bug #1037323
Patch0001:     0001-sharutils-4.14.2-Pass-compilation-with-Werror-format-security.patch
# Fix CVE-2018-1000097 (a heap buffer overflow in find_archive()),
# bug #1548019,
# <http://lists.gnu.org/archive/html/bug-gnu-utils/2018-02/msg00004.html>
Patch0002:     0002-sharutils-4.15.2-Fix-a-heap-buffer-overflow-in-find_archive.patch
# Adapt bundled gnulib to glibc-2.28
Patch0003:     0003-sharutils-4.15.2-fflush-adjust-to-glibc-2.28-libio.h-removal.patch
# Fix building with GCC 10,
# <https://lists.gnu.org/archive/html/bug-gnu-utils/2020-01/msg00001.html>
Patch0004:     0004-sharutils-4.15.2-Fix-building-with-GCC-10.patch
# Fix building with GCC 10,
# <https://lists.gnu.org/archive/html/bug-gnu-utils/2020-01/msg00001.html>
Patch0005:     0005-sharutils-4.15.2-Do-not-include-lib-md5.c-into-src-shar.c.patch

BuildRequires:      binutils
BuildRequires:      coreutils
BuildRequires:      gcc
BuildRequires:      gettext
BuildRequires:      glibc-common
BuildRequires:      make
BuildRequires:      sed
BuildRequires:      texinfo
# Tests:
BuildRequires:      diffutils

Provides:           bundled(gnulib)
# See libopts/autoopts/options.h for OPTIONS_DOTTED_VERSION
Provides:           bundled(libopts) = 41.1

%description
The sharutils package contains the GNU shar utilities, a set of tools for
encoding and decoding packages of files (in binary or text format) in
a special plain text format called shell archives (shar).  This format can be
sent through e-mail (which can be problematic for regular binary files).  The
shar utility supports a wide range of capabilities (compressing, uuencoding,
splitting long files for multi-part mailings, providing check-sums), which
make it very flexible at creating shar files.  After the files have been sent,
the unshar tool scans mail messages looking for shar files.  Unshar
automatically strips off mail headers and introductory text and then unpacks
the shar files.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

# convert TODO, THANKS to UTF-8
for i in TODO THANKS; do
  iconv -f iso-8859-1 -t utf-8 -o $i{.utf8,}
  mv $i{.utf8,}
done

%build
%configure
make %{?_smp_mflags}

%install
make DESTDIR=${RPM_BUILD_ROOT} install
rm -f ${RPM_BUILD_ROOT}%{_infodir}/dir
%find_lang %{name}

%check
make check

%generate_compatibility_deps

%files -f %{name}.lang
%license COPYING
%dir %{abidir}
%{_bindir}/*
%{abidir}/*-option.list
%{_infodir}/*info*
%{_mandir}/man1/*
%{_mandir}/man5/*

%files doc
%doc AUTHORS ChangeLog NEWS README THANKS TODO

%changelog
* Wed May 22 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 4.15.2-2
- fix source link

* Fri Mar 24 2023 yuanhui <yuanhui@linux.alibaba.com> - 4.15.2-1
- Init package from upstream
